﻿Class MainWindow
#Region "Null Checking"
  Private Sub btnCheckNull_Click(sender As Object, e As RoutedEventArgs) Handles btnCheckNull.Click
    Dim str As String = Nothing

    If MainWindow.IsStringNullOrEmpty(str) Then
      Debug.WriteLine("Empty String")
    End If

    str = ""
    If MainWindow.IsStringNullOrEmpty(str) Then
      Debug.WriteLine("Empty String")
    End If

    str = "Some Value"
    If MainWindow.IsStringNullOrEmpty(str) Then
      Debug.WriteLine("Empty String")
    Else
      Debug.WriteLine("NOT an Empty String")
    End If
  End Sub

  Public Shared Function IsStringNullOrEmpty(value As Object) As Boolean
    Dim ret As Boolean = False

    If System.DBNull.Value.Equals(value) Then
      ret = True
    ElseIf value Is Nothing Then
      ret = True
    ElseIf String.IsNullOrEmpty(value.ToString()) Then
      ret = True
    End If

    Return ret
  End Function
#End Region

#Region "Asc() and Chr() Method"
  Private Sub btnAsc_Click(sender As Object, e As RoutedEventArgs) Handles btnAsc.Click
    Dim value As Char = "A"c

    Debug.WriteLine(Asc(value))

    Debug.WriteLine(SafeAsc(value))
  End Sub

  Private Shared Function SafeAsc(ByVal str As String) As Short
    Return Convert.ToInt16(System.Text.Encoding.[Default].GetBytes(str)(0))
  End Function

  Private Sub btnChr_Click(sender As Object, e As RoutedEventArgs) Handles btnChr.Click
    Dim value As Integer = 65

    Debug.WriteLine(Chr(value))

    Debug.WriteLine(SafeChr(value))
  End Sub

  Private Shared Function SafeChr(ByVal CharCode As Integer) As String
    If CharCode > 255 Then
      Throw New ArgumentOutOfRangeException("CharCode", CharCode, "CharCode must be between 0 and 255.")
    End If
    Return System.Text.Encoding.[Default].GetString({CByte(CharCode)})
  End Function
#End Region

  Private Sub btnCBool_Click(sender As Object, e As RoutedEventArgs) Handles btnCBool.Click
    Dim str As String = "sadf"
    Dim value As Integer = -1

    Debug.WriteLine(CBool(str))
    ' The following will throw an exception if 'str' = a numeric value such as 0 or -1
    Debug.WriteLine(Convert.ToBoolean(str))
    ' When using a numeric, any non-zero value is considered true
    Debug.WriteLine(Convert.ToBoolean(value))
  End Sub

  Private Sub btnCByte_Click(sender As Object, e As RoutedEventArgs) Handles btnCByte.Click
    Dim value As Double = 41.8

    Debug.WriteLine(CByte(value))
    Debug.WriteLine(Convert.ToByte(value))
  End Sub

  Private Sub btnCChar_Click(sender As Object, e As RoutedEventArgs) Handles btnCChar.Click
    Dim value As String = "BCD"

    ' The following line of code returns "B".
    Debug.WriteLine(CChar(value))

    ' The following line will bomb if the string is > 1 character
    ' Debug.WriteLine(Convert.ToChar(aString))

    value = "B"
    Debug.WriteLine(Convert.ToChar(value))
  End Sub

  Private Sub btnCDate_Click(sender As Object, e As RoutedEventArgs) Handles btnCDate.Click
    Dim value As String = "1/1/2018"

    Debug.WriteLine(CDate(value))

    Debug.WriteLine(Convert.ToDateTime(value))
  End Sub

  Private Sub btnCDbl_Click(sender As Object, e As RoutedEventArgs) Handles btnCDbl.Click
    Dim value As Integer = 42

    Debug.WriteLine(CDbl(value))

    Debug.WriteLine(Convert.ToDouble(value))
  End Sub

  Private Sub btnCDec_Click(sender As Object, e As RoutedEventArgs) Handles btnCDec.Click
    Dim value As Integer = 42

    Debug.WriteLine(CDec(value))

    Debug.WriteLine(Convert.ToDecimal(value))
  End Sub

  Private Sub btnCInt_Click(sender As Object, e As RoutedEventArgs) Handles btnCInt.Click
    Dim value As Double = 41.8

    Debug.WriteLine(CInt(value))

    Debug.WriteLine(Convert.ToInt32(value))
  End Sub

  Private Sub btnCLng_Click(sender As Object, e As RoutedEventArgs) Handles btnCLng.Click
    Dim value As Double = 41.8

    Debug.WriteLine(CLng(value))

    Debug.WriteLine(Convert.ToInt64(value))
  End Sub

  Private Sub btnCObj_Click(sender As Object, e As RoutedEventArgs) Handles btnCObj.Click
    Dim value As Double = 41.8

    Debug.WriteLine(CObj(value))

    Debug.WriteLine(DirectCast(value, Object))
  End Sub

  Private Sub btnCShort_Click(sender As Object, e As RoutedEventArgs) Handles btnCShort.Click
    Dim value As Double = 41.8

    Debug.WriteLine(CShort(value))

    Debug.WriteLine(Convert.ToInt16(value))
  End Sub

  Private Sub btnCSng_Click(sender As Object, e As RoutedEventArgs) Handles btnCSng.Click
    Dim value As Double = 41.8

    Debug.WriteLine(CSng(value))

    Debug.WriteLine(Convert.ToSingle(value))
  End Sub

  Private Sub btnCStr_Click(sender As Object, e As RoutedEventArgs) Handles btnCStr.Click
    Dim value As Double = 41.8

    Debug.WriteLine(CStr(value))

    Debug.WriteLine(Convert.ToString(value))
    Debug.WriteLine(value.ToString())
  End Sub

  Private Sub btnFilter_Click(sender As Object, e As RoutedEventArgs) Handles btnFilter.Click
    Dim values(2) As String
    values(0) = "This"
    values(1) = "Is"
    values(2) = "It"

    Dim subset() As String
    ' Returns ["This", "Is"].
    subset = Filter(values, "is", True, CompareMethod.Text)
    subset = values.Where(Function(s) s.ToLower().Contains("is")).ToArray()
    Debugger.Break()

    ' Returns ["This"].
    subset = Filter(values, "is", True, CompareMethod.Binary)
    subset = values.Where(Function(s) s.Contains("is")).ToArray()
    Debugger.Break()

    ' Returns ["Is", "It"].
    subset = Filter(values, "is", False, CompareMethod.Binary)
    subset = values.Where(Function(s) Not s.Contains("is")).ToArray()
    Debugger.Break()

    ' Just an FYI, you can convert an array into a List(of T) using the .ToList() method on the array
    Dim strings As List(Of String) = values.ToList()
    Dim strs As List(Of String) = strings.Where(Function(s) s.Contains("is")).ToList()
    Debugger.Break()
  End Sub

  Private Sub btnFormat_Click(sender As Object, e As RoutedEventArgs) Handles btnFormat.Click
    Dim dt As Date = #1/15/2018 2:04:23 PM#

    ' Returns current system time in the system-defined long time format.
    Debug.WriteLine(Format(dt, "Long Time"))
    Debug.WriteLine(dt.ToLongTimeString())
    Debugger.Break()
    ' Returns current system date in the system-defined long date format.
    Debug.WriteLine(Format(dt, "Long Date"))
    Debug.WriteLine(dt.ToLongDateString())
    Debugger.Break()

    ' Also returns current system date in the system-defined long date 
    ' format, using the single letter code for the format.
    Debug.WriteLine(Format(dt, "D"))
    Debug.WriteLine(dt.ToLongDateString())
    Debugger.Break()

    ' Returns the value of TestDateTime in user-defined date/time formats.
    Debug.WriteLine(Format(dt, "h:m:s"))
    Debug.WriteLine(dt.ToString("h:m:s"))
    Debug.WriteLine(Format(dt, "hh:mm:ss tt"))
    Debug.WriteLine(dt.ToString("hh:mm:ss tt"))
    Debug.WriteLine(Format(dt, "dddd, MMM d yyyy"))
    Debug.WriteLine(dt.ToString("dddd, MMM d yyyy"))
    Debug.WriteLine(Format(dt, "HH:mm:ss"))
    Debug.WriteLine(dt.ToString("HH:mm:ss"))
    Debugger.Break()

    ' User-defined numeric formats.
    ' Returns "5,459.40".
    Debug.WriteLine(Format(5459.4, "##,##0.00"))
    Debug.WriteLine(5459.4.ToString("##,##0.00"))
    ' Returns "334.90".
    Debug.WriteLine(Format(334.9, "###0.00"))
    Debug.WriteLine(334.9.ToString("###0.00"))
    ' Returns "500.00%".
    Debug.WriteLine(Format(5, "0.00%"))
    Debug.WriteLine(5.ToString("0.00%"))
    Debugger.Break()
  End Sub

  Private Sub btnFormatCurrency_Click(sender As Object, e As RoutedEventArgs) Handles btnFormatCurrency.Click
    Dim value As Double = -4456.43

    ' Returns "($4,456.43)".
    Debug.WriteLine(FormatCurrency(value, , , TriState.True, TriState.True))
    Debug.WriteLine(value.ToString("C"))
    Debugger.Break()

    ' Returns "-$4,456.43".
    Debug.WriteLine(FormatCurrency(value, , , TriState.False, TriState.True))
    Debug.WriteLine(value.ToString("$#,##0.00"))
    Debugger.Break()
  End Sub

  Private Sub btnFormatDateTime_Click(sender As Object, e As RoutedEventArgs) Handles btnFormatDateTime.Click
    Debug.WriteLine("See Format() function")
  End Sub

  Private Sub btnFormatNumber_Click(sender As Object, e As RoutedEventArgs) Handles btnFormatNumber.Click
    Dim value As Integer = 45600

    ' Returns "45,600.00".
    Debug.WriteLine(FormatNumber(value, 2, , , TriState.True))
    Debug.WriteLine(value.ToString("###,##0.00"))
    Debugger.Break()
  End Sub

  Private Sub btnFormatPercent_Click(sender As Object, e As RoutedEventArgs) Handles btnFormatPercent.Click
    Dim value As Single = 0.76

    ' Returns "76.00%".
    Debug.WriteLine(FormatPercent(value))
    Debug.WriteLine(value.ToString("0.00%"))
    Debug.WriteLine(FormatPercent(value, 1))
    Debug.WriteLine(value.ToString("0.0%"))
    Debug.WriteLine(FormatPercent(value, 0))
    Debug.WriteLine(value.ToString("0%"))
    Debugger.Break()
  End Sub

  Private Sub btnInStr_Click(sender As Object, e As RoutedEventArgs) Handles btnInStr.Click
    Dim value As String = "Hello from VB"

    ' NOTE: When using VB, string methods typically are 1-based
    Debug.WriteLine(InStr(value, "from"))

    ' NOTE: When using .NET, the values are 0-based
    Debug.WriteLine(value.IndexOf("from") + 1)

    Debugger.Break()
  End Sub

  Private Sub btnInStrRev_Click(sender As Object, e As RoutedEventArgs) Handles btnInStrRev.Click
    Dim value As String = "Hello from VB"

    ' NOTE: When using VB, string methods typically are 1-based
    Debug.WriteLine(InStrRev(value, "from"))

    ' NOTE: When using .NET, the values are 0-based
    Debug.WriteLine(value.LastIndexOf("from") + 1)

    Debugger.Break()
  End Sub

  Private Sub btnJoin_Click(sender As Object, e As RoutedEventArgs) Handles btnJoin.Click
    Dim values(2) As String
    values(0) = "This"
    values(1) = "is"
    values(2) = "it."

    Debug.WriteLine(Join(values))
    Debug.WriteLine(String.Join(" ", values))
    Debugger.Break()
  End Sub

  Private Sub btnSplit_Click(sender As Object, e As RoutedEventArgs) Handles btnSplit.Click
    Dim value As String = "This is it."
    Dim values As String()

    values = Split(value)
    Debugger.Break()

    values = value.Split(" "c)
    Debugger.Break()
  End Sub

  Private Sub btnLCase_Click(sender As Object, e As RoutedEventArgs) Handles btnLCase.Click
    Dim value As String = "HELLO WORLD"

    Debug.WriteLine(LCase(value))
    Debug.WriteLine(value.ToLower())
    Debugger.Break()
  End Sub

  Private Sub btnLeft_Click(sender As Object, e As RoutedEventArgs) Handles btnLeft.Click
    Dim value As String = "Hello World"

    ' NOTE: I have to use Strings.Left here because WPF has Left() method
    Debug.WriteLine(Strings.Left(value, 5))
    Debug.WriteLine(value.Substring(0, 5))
    Debugger.Break()
  End Sub

  Private Sub btnLen_Click(sender As Object, e As RoutedEventArgs) Handles btnLen.Click
    Dim value As String = "Hello World"

    Debug.WriteLine(Len(value))
    Debug.WriteLine(value.Length)
    Debugger.Break()
  End Sub

  Private Sub btnLTrim_Click(sender As Object, e As RoutedEventArgs) Handles btnLTrim.Click
    Dim value As String = "   Hello World"

    Debug.WriteLine(LTrim(value))
    Debug.WriteLine(value.TrimStart())
    Debugger.Break()
  End Sub

  Private Sub btnMid_Click(sender As Object, e As RoutedEventArgs) Handles btnMid.Click
    Dim value As String = "Hello World"

    Debug.WriteLine(Mid(value, 7))
    Debug.WriteLine(value.Substring(6))
    Debugger.Break()
  End Sub

  Private Sub btnMsgBox_Click(sender As Object, e As RoutedEventArgs) Handles btnMsgBox.Click
    Dim value As String = "Hello World"

    MsgBox(value)
    MessageBox.Show(value)

    Dim result As MsgBoxResult = MsgBox(value, MsgBoxStyle.Exclamation)
    Dim mresult As MessageBoxResult = MessageBox.Show(value, "Caption", MessageBoxButton.OK, MessageBoxImage.Exclamation, MessageBoxResult.OK)
  End Sub

  Private Sub btnReplace_Click(sender As Object, e As RoutedEventArgs) Handles btnReplace.Click
    Dim value As String = "Hello World"

    Debug.WriteLine(Replace(value, "World", "VB"))
    Debug.WriteLine(value.Replace("World", "VB"))
    Debugger.Break()
  End Sub

  Private Sub btnRight_Click(sender As Object, e As RoutedEventArgs) Handles btnRight.Click
    Dim value As String = "Hello World"

    Debug.WriteLine(Right(value, 5))
    Debug.WriteLine(value.Substring(value.Length - 5))
    Debugger.Break()
  End Sub

  Private Sub btnRTrim_Click(sender As Object, e As RoutedEventArgs) Handles btnRTrim.Click
    Dim value As String = "Hello World   "

    Debug.WriteLine(RTrim(value))
    Debug.WriteLine(value.TrimEnd())
    Debugger.Break()
  End Sub

  Private Sub btnSpace_Click(sender As Object, e As RoutedEventArgs) Handles btnSpace.Click
    Dim value As String

    value = Space(50)
    Debugger.Break()

    value = value.PadLeft(50, " "c)
    Debugger.Break()
  End Sub

  Private Sub btnStrDup_Click(sender As Object, e As RoutedEventArgs) Handles btnStrDup.Click
    ' Returns "PPPPP"
    Debug.WriteLine(StrDup(5, "P"))
    Debug.WriteLine(New String("P"c, 5))
    Debugger.Break()
  End Sub

  Private Sub btnStrReverse_Click(sender As Object, e As RoutedEventArgs) Handles btnStrReverse.Click
    Dim value As String = "Hello World"

    Debug.WriteLine(StrReverse(value))
    ' Need to create a function to perform the Reverse using .NET
    Debug.WriteLine(ReverseString(value))
    Debugger.Break()
  End Sub

  Public Shared Function ReverseString(value As String) As String
    Dim chrs() As Char

    chrs = value.ToCharArray()
    Array.Reverse(chrs)

    Return String.Join(" ", New String(chrs))
  End Function

  Private Sub btnTrim_Click(sender As Object, e As RoutedEventArgs) Handles btnTrim.Click
    Dim value As String = "    Hello World   "

    Debug.WriteLine(Trim(value))
    Debug.WriteLine(value.Trim())
    Debugger.Break()
  End Sub

  Private Sub btnUCase_Click(sender As Object, e As RoutedEventArgs) Handles btnUCase.Click
    Dim value As String = "hello world"

    Debug.WriteLine(UCase(value))
    Debug.WriteLine(value.ToUpper())
    Debugger.Break()
  End Sub

  Private Sub btnvbCrLf_Click(sender As Object, e As RoutedEventArgs) Handles btnvbCrLf.Click
    Dim value As String = "Hello World" & vbNewLine & "Hello VB" & vbCrLf & "Hello To You"
    Dim newValue As String = "Hello World" & Environment.NewLine & "Hello VB" & Environment.NewLine & "Hello To You"

    Debug.WriteLine(value)
    Debug.WriteLine(" ")
    Debug.WriteLine(newValue)
    Debugger.Break()
  End Sub
End Class
